## ignition-cmake 2.11.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)

#============================================================================
# Initialize the project
#============================================================================
project(ignition-cmake2 VERSION 2.11.0)

#--------------------------------------
# Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
# directory that sits next to this find-module.
set(IGNITION_CMAKE_DIR "${CMAKE_CURRENT_LIST_DIR}/cmake")

#--------------------------------------
# Add the location of this package's cmake directory to the CMAKE_MODULE_PATH
list(APPEND CMAKE_MODULE_PATH "${IGNITION_CMAKE_DIR}")

#--------------------------------------
# include the master IgnCMake module
include(IgnCMake)

#--------------------------------------
# Set up the project
ign_configure_project(VERSION_SUFFIX)

#--------------------------------------
# Set project-specific options
option(BUILDSYSTEM_TESTING "Enable extended buildsystem testing" FALSE)

#--------------------------------------
# Install the ignition documentation files
# Note: This is not actually creating a doc target for ign-cmake; this is just
# installing files that are useful for generating the documentation of other
# ignition projects.
add_subdirectory(doc)

#--------------------------------------
# Install the benchmark files
install(DIRECTORY benchmark/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/benchmark)

#--------------------------------------
# Install the codecheck files
install(DIRECTORY codecheck/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/codecheck)

#--------------------------------------
# Install the tools files
install(DIRECTORY tools/
        DESTINATION ${IGN_DATA_INSTALL_DIR}/tools)

#============================================================================
# Configure the package to be installed
#============================================================================

#--------------------------------------
# Create configuration and installation variables
set(ign_config_input  "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake-config.cmake.in")
set(ign_config_output "${PROJECT_NAME_LOWER}-config.cmake")
set(ign_version_output "${PROJECT_NAME_LOWER}-config-version.cmake")
set(ign_config_install_dir "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME_LOWER}")
set(ign_pkgconfig_input "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake.pc.in")
set(ign_pkgconfig_output "${CMAKE_BINARY_DIR}/ignition-cmake${PROJECT_VERSION_MAJOR}.pc")
set(ign_pkgconfig_install_dir "${IGN_LIB_INSTALL_DIR}/pkgconfig")
set(ign_utilities_target ${PROJECT_EXPORT_NAME}-utilities)
set(ign_utilities_import_target_name ${PROJECT_EXPORT_NAME}::${ign_utilities_target})
set(ign_utilities_target_output_filename "${ign_utilities_target}-targets.cmake")
set(simple_utilities_import_name ${PROJECT_EXPORT_NAME}::utilities)

#--------------------------------------
# Configure and install the config file
configure_package_config_file(
  ${ign_config_input}
  ${ign_config_output}
  INSTALL_DESTINATION ${ign_config_install_dir}
  PATH_VARS IGN_DATA_INSTALL_DIR
  NO_CHECK_REQUIRED_COMPONENTS_MACRO)

#--------------------------------------
# Configure and install the version file
write_basic_package_version_file(
  ${CMAKE_CURRENT_BINARY_DIR}/${ign_version_output}
  VERSION "${PROJECT_VERSION_FULL_NO_SUFFIX}"
  COMPATIBILITY SameMajorVersion)

install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/${ign_config_output}
    ${CMAKE_CURRENT_BINARY_DIR}/${ign_version_output}
  DESTINATION ${ign_config_install_dir}
  COMPONENT cmake)

#--------------------------------------
# Configure and install the pkgconfig file (needed for utilities headers)
file(RELATIVE_PATH
  IGN_PC_CONFIG_RELATIVE_PATH_TO_PREFIX
  "${CMAKE_INSTALL_PREFIX}/${ign_pkgconfig_install_dir}"
  "${CMAKE_INSTALL_PREFIX}"
)
configure_file(${ign_pkgconfig_input} ${ign_pkgconfig_output} @ONLY)

install(
  FILES ${ign_pkgconfig_output}
  DESTINATION ${ign_pkgconfig_install_dir}
  COMPONENT pkgconfig)

#============================================================================
# Create and install the utilities component
#============================================================================
add_library(${ign_utilities_target} INTERFACE)
target_include_directories(${ign_utilities_target}
  INTERFACE
    $<INSTALL_INTERFACE:${IGN_INCLUDE_INSTALL_DIR_FULL}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>)

# Export and install the interface target
install(
  TARGETS ${ign_utilities_target}
  EXPORT ${ign_utilities_target}
  COMPONENT interface)

export(
  EXPORT ${ign_utilities_target}
  FILE ${ign_utilities_target_output_filename}
  NAMESPACE ${PROJECT_EXPORT_NAME}::)

install(
  EXPORT ${ign_utilities_target}
  DESTINATION ${ign_config_install_dir}
  FILE ${ign_utilities_target_output_filename}
  NAMESPACE ${PROJECT_EXPORT_NAME}::)

# Install the header directory
# Note: The trailing slash after "include" is necessary
install(
  DIRECTORY include/
  DESTINATION ${IGN_INCLUDE_INSTALL_DIR_FULL}
  COMPONENT headers)

#============================================================================
# Install the files for this package
#============================================================================
set(ign_modules_install_dir "${ign_config_install_dir}/cmake${PROJECT_VERSION_MAJOR}")

file(GLOB modules "cmake/*.cmake")
file(GLOB templates "cmake/*.in")

install(
  FILES ${modules} ${templates}
  DESTINATION ${ign_modules_install_dir}
  COMPONENT modules)

file(GLOB pkgconfig_templates "cmake/pkgconfig/*.in")

install(
  FILES ${pkgconfig_templates}
  DESTINATION ${ign_modules_install_dir}/pkgconfig
  COMPONENT modules)

message(STATUS "Install prefix: ${CMAKE_INSTALL_PREFIX}")

include(CTest)
if (BUILD_TESTING)
  add_subdirectory(test)
endif()

if (BUILD_TESTING AND BUILDSYSTEM_TESTING)
  #============================================================================
  # Build examples
  #============================================================================
  # Do a fake install of ign-cmake in order to test the examples.
  # Copy or symlink the config.cmake files and cmake folder
  set(FAKE_BUILD_DIRECTORY "${CMAKE_BINARY_DIR}/fake/build")
  set(FAKE_INSTALL_PREFIX "${CMAKE_BINARY_DIR}/fake/install")

  file(MAKE_DIRECTORY ${FAKE_BUILD_DIRECTORY})
  file(MAKE_DIRECTORY ${FAKE_INSTALL_PREFIX})

  include(ExternalProject)
  ExternalProject_Add(
    FAKE_INSTALL

    SOURCE_DIR "${CMAKE_SOURCE_DIR}"
    # BUILD_ALWAYS needed since cmake doesn't notice when
    # example files change.
    # See alternate approach in a2113e0997c9 if this becomes too slow
    BUILD_ALWAYS 1
    CMAKE_ARGS
      "-DBUILD_TESTING=OFF"
      "-DCMAKE_INSTALL_PREFIX=${FAKE_INSTALL_PREFIX}"
  )

  add_subdirectory(examples)
endif()

# Codecheck
set(CPPCHECK_DIRS
  ${CMAKE_SOURCE_DIR}/examples
)
set(CPPCHECK_INCLUDE_DIRS
  ${CMAKE_SOURCE_DIR}/include
  ${CMAKE_SOURCE_DIR}/examples
)
set(IGNITION_CMAKE_CODECHECK_DIR "${CMAKE_CURRENT_SOURCE_DIR}/codecheck")
include(IgnCodeCheck)
ign_setup_target_for_codecheck()

# Docs
set(IGNITION_CMAKE_DOXYGEN_DIR "${CMAKE_CURRENT_SOURCE_DIR}/doc/doxygen")
configure_file(${CMAKE_SOURCE_DIR}/api.md.in ${CMAKE_BINARY_DIR}/api.md)
configure_file(${CMAKE_SOURCE_DIR}/tutorials.md.in ${CMAKE_BINARY_DIR}/tutorials.md)
ign_create_docs(
  API_MAINPAGE_MD "${CMAKE_BINARY_DIR}/api.md"
  TUTORIALS_MAINPAGE_MD "${CMAKE_BINARY_DIR}/tutorials.md"
  )

=== examples/CMakeLists.txt ===
include(ExternalProject)
include(GNUInstallDirs)

# test multiple build types
set(build_types Release RelWithDebInfo Debug)
find_program(EXAMPLE_LCOV_PATH lcov)
if (NOT WIN32 AND EXAMPLE_LCOV_PATH)
  list(APPEND build_types Coverage)
endif()

set(example_directories
  ign_conf
  no_ignition_prefix
  prerelease
  core_nodep
  core_nodep_static
  core_child
  core_child_private
  core_static_child
  comp_deps
  )
if (NOT CMAKE_GENERATOR MATCHES "Visual Studio")
  list(APPEND example_directories
    use_component_depsA
    use_component_depsB
    use_component_depsC
  )
endif()

foreach(example ${example_directories})
  set(run_codecheck false)
  if (${example} STREQUAL "ign_conf")
    set(example_tarball_name ignition-minimal-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "no_ignition_prefix")
    set(example_tarball_name no_ignition_prefix-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "prerelease")
    set(example_tarball_name ignition-minimal-1.0.0~pre1.tar.bz2)
  elseif (${example} STREQUAL "core_nodep")
    set(example_tarball_name ignition-core_no_deps-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "core_nodep_static")
    set(example_tarball_name ignition-core_no_deps_static-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "core_child")
    set(example_tarball_name ignition-core_child-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "core_child_private")
    set(example_tarball_name ignition-core_child_private-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "core_static_child")
    set(example_tarball_name ignition-core_static_child-0.1.0.tar.bz2)
    set(run_codecheck true)
  elseif (${example} STREQUAL "comp_deps")
    set(example_tarball_name ignition-component_deps-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsA")
    set(example_tarball_name ignition-use_component_depsa-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsB")
    set(example_tarball_name ignition-use_component_depsb-0.1.0.tar.bz2)
  elseif (${example} STREQUAL "use_component_depsC")
    set(example_tarball_name ignition-use_component_depsc-0.1.0.tar.bz2)
  else()
    set(example_tarball_name)
  endif()

  foreach (build_type ${build_types})
    set(TEST_NAME ${example}_${build_type})
    string(TIMESTAMP TEST_TIME)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/junit_pass.xml.in"
      "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
      @ONLY)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/junit_fail.xml.in"
      "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
      @ONLY)
    set(example_INSTALL_DIR ${CMAKE_BINARY_DIR}/install/${build_type})
    ExternalProject_Add(
      ${TEST_NAME}

      DEPENDS FAKE_INSTALL
      SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/${example}"
      # BUILD_ALWAYS needed since cmake doesn't notice when
      # example files change.
      # See alternate approach in a2113e0997c9 if this becomes too slow
      BUILD_ALWAYS 1
      CMAKE_ARGS
        "-DCMAKE_PREFIX_PATH=${FAKE_INSTALL_PREFIX};${example_INSTALL_DIR}"
        "-DCMAKE_BUILD_TYPE=${build_type}"
        "-DCMAKE_INSTALL_PREFIX=${example_INSTALL_DIR}"
      TEST_COMMAND
        ${CMAKE_COMMAND} -E copy
        "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
        "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
    )
    if (${run_codecheck} AND TARGET codecheck)
      if(CMAKE_GENERATOR MATCHES "Unix Makefiles")
        ExternalProject_Add_Step(
          ${TEST_NAME}
          codecheck
          COMMAND
            $(MAKE) -C <BINARY_DIR> codecheck
          DEPENDEES
            configure
        )
      else()
        ExternalProject_Add_Step(
          ${TEST_NAME}
          codecheck
          COMMAND
            ${CMAKE_COMMAND} --build <BINARY_DIR> --target codecheck
          DEPENDEES
            configure
        )
      endif()
    endif()
    if (CPACK_GENERATOR)
      if(CMAKE_GENERATOR MATCHES "Unix Makefiles")
        ExternalProject_Add_Step(
          ${TEST_NAME}
          package_source
          COMMAND
            $(MAKE) -C <BINARY_DIR> package_source
          DEPENDEES
            configure
        )
      else()
        ExternalProject_Add_Step(
          ${TEST_NAME}
          package_source
          COMMAND
            ${CMAKE_COMMAND} --build <BINARY_DIR> --target package_source
          DEPENDEES
            configure
        )
      endif()

      ExternalProject_Add_Step(
        ${TEST_NAME}
        test_tarball_name
        COMMAND
          ${CMAKE_COMMAND} -E tar tf <BINARY_DIR>/${example_tarball_name}
        DEPENDEES
          package_source
        DEPENDERS
          test
      )
    endif()
    add_test(
      ${TEST_NAME}
      ${CMAKE_COMMAND} -E copy
      "${CMAKE_CURRENT_BINARY_DIR}/test_results/${TEST_NAME}.xml"
      "${CMAKE_BINARY_DIR}/test_results/${TEST_NAME}.xml"
    )
  endforeach()

endforeach()

# dependencies between external projects
# hard to use DEPENDS in ExternalProject_Add because targets
# need to exist before they can be used there
foreach (build_type ${build_types})
  add_dependencies(core_child_${build_type} core_nodep_${build_type})
  add_dependencies(core_child_private_${build_type} core_nodep_${build_type})
  add_dependencies(core_static_child_${build_type} core_nodep_static_${build_type})
  if (TARGET use_component_depsA_${build_type})
    add_dependencies(use_component_depsA_${build_type} comp_deps_${build_type})
  endif()
  if (TARGET use_component_depsB_${build_type})
    add_dependencies(use_component_depsB_${build_type} comp_deps_${build_type})
  endif()
  if (TARGET use_component_depsC_${build_type})
    add_dependencies(use_component_depsC_${build_type} comp_deps_${build_type})
  endif()
endforeach()

# test that core_child pkg-config file requires core_nodep
# and that core_child_private pkg-config file requires core_nodep privately
if (UNIX)
  set(TEST_NAME core_child_requires_core_nodep)
  string(TIMESTAMP TEST_TIME)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/junit_pass.xml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_pass.xml"
    @ONLY)
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/junit_fail.xml.in"
    "${CMAKE_CURRENT_BINARY_DIR}/${TEST_NAME}_fail.xml"
    @ONLY)
  set(_env_vars)
  # On Debian and if the install prefix is /usr, the default CMAKE_INSTALL_LIBDIR of this project
  # as set by GNUInstallDirs will be different from the one of the example project, 
  # so let's hardcode it in that case
  if(EXISTS "/etc/debian_version" AND "${CMAKE_INSTALL_PREFIX}" MATCHES "^/usr/?$")
    set(example_PKGCONFIG_INSTALL_LIBDIR "lib/pkgconfig")
  else()
    set(example_PKGCONFIG_INSTALL_LIBDIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
  endif()

  list(APPEND _env_vars "PKG_CONFIG_PATH=${example_INSTALL_DIR}/${example_PKGCONFIG_INSTALL_LIBDIR}:${FAKE_INSTALL_PREFIX}/${example_PKGCONFIG_INSTALL_LIBDIR}:$PKG_CONFIG_PATH")
  add_test(${TEST_NAME}
    ${CMAKE_CURRENT_SOURCE_DIR}/test_core_child_requires_core_no_deps.bash
  )
  set_tests_properties(${TEST_NAME} PROPERTIES
    ENVIRONMENT "${_env_vars}")
endif()

=== examples/core_nodep/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-core_no_deps VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs()

=== examples/core_static_child/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-core_static_child VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
ign_find_package(ignition-core_no_deps_static REQUIRED)
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs(TAGFILES "${IGNITION-CORE_NO_DEPS_STATIC_DOXYGEN_TAGFILE} = ${IGNITION-CORE_NO_DEPS_STATIC_API_URL}")

=== examples/no_ignition_prefix/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(no_ignition_prefix VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project(
  NO_IGNITION_PREFIX
  REPLACE_IGNITION_INCLUDE_PATH no_ign)
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs()

=== examples/core_child/src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 11)
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-core_no_deps::ignition-core_no_deps)
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

=== examples/core_static_child/src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 11)
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-core_no_deps_static::ignition-core_no_deps_static)
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

=== examples/use_component_depsA/src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)
ign_create_core_library(SOURCES ${sources} CXX_STANDARD 11)
target_link_libraries(${PROJECT_LIBRARY_TARGET_NAME}
  PUBLIC
    ignition-component_deps::ignition-component_deps-child)
ign_build_tests(TYPE UNIT SOURCES ${gtest_sources})

=== debian/changelog ===
ignition-cmake (2.11.0-1) unstable; urgency=medium

  * New upstream version 2.11.0

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Mon, 07 Mar 2022 16:01:20 +0000

=== debian/control ===
Source: ignition-cmake
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
Section: science
Priority: optional
Build-Depends: cmake,
               debhelper-compat (= 13),
               libjs-mathjax,
               libgtest-dev,
               pkg-config,
               python3
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/science-team/ignition-cmake
Vcs-Git: https://salsa.debian.org/science-team/ignition-cmake.git
Rules-Requires-Root: no
Homepage: https://ignitionrobotics.org/libs/cmake

Package: libignition-cmake-dev
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends: ${misc:Depends}, pkg-config
Description: Ignition Robotics CMake Library - Development files
 CMake modules to be used by the Ignition projects.
 .
 This package is required to build ignition projects, as well as to link your
 third party projects against them. It provides modules that are used to find
 dependencies of ignition projects and generate cmake targets for consumers of
 ignition projects to link against.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_install


override_dh_auto_install:
	# Remove artifacts installed by testing
	dh_auto_install
	find . -type d -name install | xargs rm -rf
	find . -type d -empty -delete

%:
	dh $@

## ignition-cmake 2.17.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 #============================================================================
 # Initialize the project
 #============================================================================
-project(ignition-cmake2 VERSION 2.11.0)
+project(ignition-cmake2 VERSION 2.17.1)
 
 #--------------------------------------
 # Initialize the IGNITION_CMAKE_DIR variable with the location of the cmake
@@ -20,7 +20,10 @@
 
 #--------------------------------------
 # Set up the project
-ign_configure_project(VERSION_SUFFIX)
+ign_configure_project(
+  REPLACE_IGNITION_INCLUDE_PATH gz/cmake
+  VERSION_SUFFIX
+)
 
 #--------------------------------------
 # Set project-specific options
@@ -60,7 +63,7 @@
 set(ign_config_install_dir "${CMAKE_INSTALL_DATAROOTDIR}/cmake/${PROJECT_NAME_LOWER}")
 set(ign_pkgconfig_input "${CMAKE_CURRENT_SOURCE_DIR}/config/ignition-cmake.pc.in")
 set(ign_pkgconfig_output "${CMAKE_BINARY_DIR}/ignition-cmake${PROJECT_VERSION_MAJOR}.pc")
-set(ign_pkgconfig_install_dir "${IGN_LIB_INSTALL_DIR}/pkgconfig")
+set(ign_pkgconfig_install_dir "${CMAKE_INSTALL_FULL_LIBDIR}/pkgconfig")
 set(ign_utilities_target ${PROJECT_EXPORT_NAME}-utilities)
 set(ign_utilities_import_target_name ${PROJECT_EXPORT_NAME}::${ign_utilities_target})
 set(ign_utilities_target_output_filename "${ign_utilities_target}-targets.cmake")
@@ -93,9 +96,17 @@
 # Configure and install the pkgconfig file (needed for utilities headers)
 file(RELATIVE_PATH
   IGN_PC_CONFIG_RELATIVE_PATH_TO_PREFIX
-  "${CMAKE_INSTALL_PREFIX}/${ign_pkgconfig_install_dir}"
+  "${ign_pkgconfig_install_dir}"
   "${CMAKE_INSTALL_PREFIX}"
 )
+
+# TODO(jrivero): CMake 3.20 provides cmake_path(APPEND) which implements the
+# same functionality as join_paths(). Remove JoinPaths in the next major version
+# if all the supported platforms are in 3.20 version.
+include(JoinPaths)
+join_paths(IGN_PC_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
+join_paths(IGN_PC_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}" "${IGN_INCLUDE_INSTALL_DIR_POSTFIX}")
+
 configure_file(${ign_pkgconfig_input} ${ign_pkgconfig_output} @ONLY)
 
 install(

=== examples/CMakeLists.txt ===
--- 
+++ 
@@ -18,6 +18,7 @@
   core_child_private
   core_static_child
   comp_deps
+  use_config_ifp
   )
 if (NOT CMAKE_GENERATOR MATCHES "Visual Studio")
   list(APPEND example_directories
@@ -58,6 +59,9 @@
     set(example_tarball_name ignition-use_component_depsb-0.1.0.tar.bz2)
   elseif (${example} STREQUAL "use_component_depsC")
     set(example_tarball_name ignition-use_component_depsc-0.1.0.tar.bz2)
+  elseif (${example} STREQUAL "use_config_ifp")
+    set(example_tarball_name  ignition-find_config-0.1.0.tar.bz2)
+
   else()
     set(example_tarball_name)
   endif()
@@ -203,3 +207,31 @@
   set_tests_properties(${TEST_NAME} PROPERTIES
     ENVIRONMENT "${_env_vars}")
 endif()
+
+if(UNIX)
+  # Test for the sanitizers example
+  set(sanitizer_compiler_log ${CMAKE_BINARY_DIR}/examples/Sanitizers-prefix/src/Sanitizers-stamp/Sanitizers-build-out.log)
+  ExternalProject_Add(
+    Sanitizers
+
+    DEPENDS FAKE_INSTALL
+    SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/sanitizers"
+    LOG_BUILD ON
+    LOG_CONFIGURE ON
+    # BUILD_ALWAYS needed since cmake doesn't notice when
+    # example files change.
+    # See alternate approach in a2113e0997c9 if this becomes too slow
+    BUILD_ALWAYS 1
+    BUILD_COMMAND ${CMAKE_COMMAND} --build . --clean-first
+    CMAKE_ARGS
+      "-DCMAKE_PREFIX_PATH=${FAKE_INSTALL_PREFIX};${example_INSTALL_DIR}"
+      "-DCMAKE_BUILD_TYPE=RelWithDebInfo"
+      "-DCMAKE_INSTALL_PREFIX=${CMAKE_BINARY_DIR}/install/Sanitizers"
+      "-DIGN_SANITIZER=Address"
+      "-DCMAKE_CXX_FLAGS=-Wno-unused-parameter"
+      "-DCMAKE_VERBOSE_MAKEFILE:BOOL=ON"
+    TEST_COMMAND
+      # Multiplatform python equivalent to grep "fsanitize=address" "${sanitizer_compiler_log}"
+      python3 -c "exec(\"import sys\\nwith open('${sanitizer_compiler_log}') as f:sys.exit(0) if 'fsanitize=address' in f.read() else sys.exit(1)\")"
+  )
+endif()

=== examples/core_nodep_static/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-core_no_deps_static VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
OPTION(BUILD_SHARED_LIBS OFF)
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()
ign_create_docs()

=== examples/sanitizers/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-sanitizers VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
ign_configure_project()
ign_configure_build(QUIT_IF_BUILD_ERRORS)

=== examples/use_config_ifp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-find_config VERSION 0.1.0)
find_package(ignition-cmake2 REQUIRED)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/")
set(ignition-find_config_DIR "${CMAKE_SOURCE_DIR}/")
#ign_find_package(ignition-find_config) will search for Findignition-find_config.cmake before ignition-find_configConfig.cmake 
ign_find_package(ignition-find_config)
if(CONFIG_TEST MATCHES "The package was found using MODULE mode")
  message(STATUS "The package was found using MODULE mode")
else()  
  message(SEND_ERROR "Couldn't find correct package in MODULE mode.\nign_find_package CONFIG test failed")
endif()
#After CONFIG arguemnt ign_find_package will skip MODULE mode and search for ignition-find_configConfig.cmake directly
ign_find_package(ignition-find_config CONFIG)
if(CONFIG_TEST MATCHES "The package was found using CONFIG mode")
  message(STATUS "The package was found using CONFIG mode")
else()
  message(SEND_ERROR "Couldn't find correct package in CONFIG mode.\nign_find_package CONFIG test failed")
endif()
ign_configure_project()
ign_configure_build(QUIT_IF_BUILD_ERRORS)
ign_create_packages()

=== examples/find_ogre2/ogre-2.1/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10.2 FATAL_ERROR)
project(ignition-ogre-2.1 VERSION 0.1.0)

find_package(ignition-cmake2 REQUIRED)

message(STATUS "Finding OGRE 2.1")

ign_find_package(IgnOGRE2 VERSION 2.1.0
    COMPONENTS HlmsPbs HlmsUnlit Overlay)

message(STATUS "OGRE2_FOUND: " ${OGRE2_FOUND})
message(STATUS "OGRE2_LIBRARIES: " ${OGRE2_LIBRARIES})
message(STATUS "OGRE2_INCLUDE_DIRS: " ${OGRE2_INCLUDE_DIRS})
message(STATUS "OGRE2_VERSION: " ${OGRE2_VERSION})
message(STATUS "OGRE2_VERSION_MAJOR: " ${OGRE2_VERSION_MAJOR})
message(STATUS "OGRE2_VERSION_MINOR: " ${OGRE2_VERSION_MINOR})
message(STATUS "OGRE2_VERSION_PATCH: " ${OGRE2_VERSION_PATCH})
message(STATUS "OGRE2_RESOURCE_PATH: " ${OGRE2_RESOURCE_PATH})

=== examples/sanitizers/src/CMakeLists.txt ===
ign_get_libsources_and_unittests(sources gtest_sources)
ign_add_executable(asanfail ${sources})
add_test(asan asanfail)

=== debian/changelog ===
ignition-cmake (2.17.1-2ubuntu1) noble; urgency=medium

  * d/t/control: Add allow-stderr to "Restrictions:" (LP: #2048518)

 -- Mate Kukri <mate.kukri@canonical.com>  Mon, 08 Jan 2024 13:37:10 +0000

ignition-cmake (2.17.1-2) unstable; urgency=medium

  * Team upload.
  * Replace deprecated exec_program() with execute_process()

 -- Timo Röhling <roehling@debian.org>  Thu, 14 Dec 2023 13:28:48 +0100

ignition-cmake (2.17.1-1) unstable; urgency=medium

  * New upstream version 2.17.1

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Thu, 07 Sep 2023 13:52:42 +0000

ignition-cmake (2.17.0-1) unstable; urgency=medium

  * New upstream version 2.17.0
  * Rediff patches

 -- Jose Luis Rivero <jrivero@osrfoundation.org>  Wed, 09 Aug 2023 18:36:03 +0000

ignition-cmake (2.11.0-2) unstable; urgency=medium

  * Team upload.

  [ Jose Luis Rivero ]
  * Rediff patches

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Timo Röhling ]
  * Silence CMP0148 warning about PythonInterp

 -- Timo Röhling <roehling@debian.org>  Tue, 11 Jul 2023 00:21:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: ignition-cmake
-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Jose Luis Rivero <jrivero@osrfoundation.org>
 Section: science
 Priority: optional
@@ -9,7 +10,7 @@
                libgtest-dev,
                pkg-config,
                python3
-Standards-Version: 4.6.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/science-team/ignition-cmake
 Vcs-Git: https://salsa.debian.org/science-team/ignition-cmake.git
 Rules-Requires-Root: no

=== debian/rules ===
--- 
+++ 
@@ -9,5 +9,10 @@
 	find . -type d -name install | xargs rm -rf
 	find . -type d -empty -delete
 
+
+override_dh_fixperms:
+	dh_fixperms
+	chmod +x debian/libignition-cmake-dev/usr/share/ignition/ignition-cmake2/tools/doc_check.sh
+
 %:
 	dh $@

=== debian/tests/control ===
Tests: build
Depends: libignition-cmake-dev, cmake, g++, pkg-config
Restrictions: allow-stderr
